/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

char8 str[100]="";
char8 UART_Rx_Buffer[100] = "";
uint8 UART_RxIndex = 0;
volatile _Bool UART_RxReceiveDone = 0;
uint16 i;

 CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;
   
// custom ISR
CY_ISR_PROTO(UART_RX_ISR);


/***********************************************
 Function to handle the BLE stack
***********************************************/
void BleCallBack(uint32 event, void* eventParam)
{
    CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;
    
    switch(event)
    {
        /* if there is a disconnect or the stack just turned on from a reset then */
        case CYBLE_EVT_STACK_ON:
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
                CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
        break;
                
        
        case CYBLE_EVT_GATT_CONNECT_IND:
             uart_UartPutString("Device connected\r\n");
        break;
                
        /* handle a write request */
        case CYBLE_EVT_GATTS_WRITE_REQ:
                wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *)eventParam;
                
                /* request write the LED value */
                if(wrReqParam->handleValPair.attrHandle == CYBLE_BLEUART_BLEUART_CHAR_HANDLE)
                {
                     
                    /* only update the value and write the response if the requested write is allowed */   
                    if(CYBLE_GATT_ERR_NONE == CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair,0,&cyBle_connHandle,CYBLE_GATT_DB_PEER_INITIATED))
                    {
                       
                       // strcpy(stt,&wrReqParam->handleValPair.value.val);
                        for(i=0;i<wrReqParam->handleValPair.value.len;i++)
                        {
                        str[i]=wrReqParam->handleValPair.value.val[i];
                        }
                         uart_UartPutString(str);
           
                        memset(str,'\0',100);
                        CyBle_GattsWriteRsp(cyBle_connHandle);
                         }
                    
                }
                break;
            default:
                break;
                
    }
}


CY_ISR(UART_RX_ISR)
{
    uart_ClearRxInterruptSource(uart_INTR_RX_NOT_EMPTY ); //clear interrupt
    
    // check UART Rx Buffer size 
    if(0 != uart_GET_RX_FIFO_ENTRIES)   
    {
        // Read data from UART Rx FIFO
        char8 UART_ch = (char8) uart_RX_FIFO_RD_REG;
        if(UART_ch != '\0')
        {  
          if(UART_ch != '\r' && UART_ch != '\n'){
                UART_Rx_Buffer[UART_RxIndex] = UART_ch;
                UART_RxIndex++;
            }
            else{
                UART_RxReceiveDone = 1;
                uart_CLEAR_RX_FIFO;
            }    
        
        }
    }   
}

/**********************************************************
Function to update the received data from uart in the GATT database
**********************************************************/
void updateToBle()
{
    if(CyBle_GetState() != CYBLE_STATE_CONNECTED)
        return;
    
    CYBLE_GATTS_HANDLE_VALUE_NTF_T tempHandle;
    
    tempHandle.attrHandle = CYBLE_BLEUART_BLEUART_CHAR_HANDLE;
    tempHandle.value.val = UART_Rx_Buffer;
    tempHandle.value.len = UART_RxIndex;
    CyBle_GattsWriteAttributeValue(&tempHandle,0,&cyBle_connHandle,CYBLE_GATT_DB_LOCALLY_INITIATED);
}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    
    uart_Start();
    uart_rx_isr_StartEx(UART_RX_ISR);
    uart_UartPutString("UART Started\r\n");
    
    CyBle_Start(BleCallBack);
   
    for(;;)
    {
        if(UART_RxReceiveDone){
            UART_RxReceiveDone = 0;
            uart_UartPutString(UART_Rx_Buffer);
            updateToBle();
            UART_RxIndex = 0;
            memset(UART_Rx_Buffer,'\0',100);
        }
        CyBle_ProcessEvents();
       
    }
}



/* [] END OF FILE */
